<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCadProduto ArrayType
 * @subpackage Arrays
 */
class ArrayOfCadProduto extends AbstractStructArrayBase
{
    /**
     * The CadProduto
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CadProduto[]
     */
    public $CadProduto;
    /**
     * Constructor method for ArrayOfCadProduto
     * @uses ArrayOfCadProduto::setCadProduto()
     * @param \StructType\CadProduto[] $cadProduto
     */
    public function __construct(array $cadProduto = array())
    {
        $this
            ->setCadProduto($cadProduto);
    }
    /**
     * Get CadProduto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CadProduto[]|null
     */
    public function getCadProduto()
    {
        return isset($this->CadProduto) ? $this->CadProduto : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCadProduto method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCadProduto method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCadProdutoForArrayConstraintsFromSetCadProduto(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCadProdutoCadProdutoItem) {
            // validation for constraint: itemType
            if (!$arrayOfCadProdutoCadProdutoItem instanceof \StructType\CadProduto) {
                $invalidValues[] = is_object($arrayOfCadProdutoCadProdutoItem) ? get_class($arrayOfCadProdutoCadProdutoItem) : sprintf('%s(%s)', gettype($arrayOfCadProdutoCadProdutoItem), var_export($arrayOfCadProdutoCadProdutoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CadProduto property can only contain items of type \StructType\CadProduto, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CadProduto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CadProduto[] $cadProduto
     * @return \ArrayType\ArrayOfCadProduto
     */
    public function setCadProduto(array $cadProduto = array())
    {
        // validation for constraint: array
        if ('' !== ($cadProdutoArrayErrorMessage = self::validateCadProdutoForArrayConstraintsFromSetCadProduto($cadProduto))) {
            throw new \InvalidArgumentException($cadProdutoArrayErrorMessage, __LINE__);
        }
        if (is_null($cadProduto) || (is_array($cadProduto) && empty($cadProduto))) {
            unset($this->CadProduto);
        } else {
            $this->CadProduto = $cadProduto;
        }
        return $this;
    }
    /**
     * Add item to CadProduto value
     * @throws \InvalidArgumentException
     * @param \StructType\CadProduto $item
     * @return \ArrayType\ArrayOfCadProduto
     */
    public function addToCadProduto(\StructType\CadProduto $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CadProduto) {
            throw new \InvalidArgumentException(sprintf('The CadProduto property can only contain items of type \StructType\CadProduto, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CadProduto[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CadProduto|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CadProduto|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CadProduto|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CadProduto|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CadProduto|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CadProduto
     */
    public function getAttributeName()
    {
        return 'CadProduto';
    }
}
