<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCancelamento ArrayType
 * @subpackage Arrays
 */
class ArrayOfCancelamento extends AbstractStructArrayBase
{
    /**
     * The Cancelamento
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Cancelamento[]
     */
    public $Cancelamento;
    /**
     * Constructor method for ArrayOfCancelamento
     * @uses ArrayOfCancelamento::setCancelamento()
     * @param \StructType\Cancelamento[] $cancelamento
     */
    public function __construct(array $cancelamento = array())
    {
        $this
            ->setCancelamento($cancelamento);
    }
    /**
     * Get Cancelamento value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Cancelamento[]|null
     */
    public function getCancelamento()
    {
        return isset($this->Cancelamento) ? $this->Cancelamento : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCancelamento method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCancelamento method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCancelamentoForArrayConstraintsFromSetCancelamento(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCancelamentoCancelamentoItem) {
            // validation for constraint: itemType
            if (!$arrayOfCancelamentoCancelamentoItem instanceof \StructType\Cancelamento) {
                $invalidValues[] = is_object($arrayOfCancelamentoCancelamentoItem) ? get_class($arrayOfCancelamentoCancelamentoItem) : sprintf('%s(%s)', gettype($arrayOfCancelamentoCancelamentoItem), var_export($arrayOfCancelamentoCancelamentoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Cancelamento property can only contain items of type \StructType\Cancelamento, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Cancelamento value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Cancelamento[] $cancelamento
     * @return \ArrayType\ArrayOfCancelamento
     */
    public function setCancelamento(array $cancelamento = array())
    {
        // validation for constraint: array
        if ('' !== ($cancelamentoArrayErrorMessage = self::validateCancelamentoForArrayConstraintsFromSetCancelamento($cancelamento))) {
            throw new \InvalidArgumentException($cancelamentoArrayErrorMessage, __LINE__);
        }
        if (is_null($cancelamento) || (is_array($cancelamento) && empty($cancelamento))) {
            unset($this->Cancelamento);
        } else {
            $this->Cancelamento = $cancelamento;
        }
        return $this;
    }
    /**
     * Add item to Cancelamento value
     * @throws \InvalidArgumentException
     * @param \StructType\Cancelamento $item
     * @return \ArrayType\ArrayOfCancelamento
     */
    public function addToCancelamento(\StructType\Cancelamento $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Cancelamento) {
            throw new \InvalidArgumentException(sprintf('The Cancelamento property can only contain items of type \StructType\Cancelamento, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Cancelamento[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Cancelamento|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Cancelamento|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Cancelamento|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Cancelamento|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Cancelamento|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Cancelamento
     */
    public function getAttributeName()
    {
        return 'Cancelamento';
    }
}
