<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCancelamentoEntrega ArrayType
 * @subpackage Arrays
 */
class ArrayOfCancelamentoEntrega extends AbstractStructArrayBase
{
    /**
     * The CancelamentoEntrega
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CancelamentoEntrega[]
     */
    public $CancelamentoEntrega;
    /**
     * Constructor method for ArrayOfCancelamentoEntrega
     * @uses ArrayOfCancelamentoEntrega::setCancelamentoEntrega()
     * @param \StructType\CancelamentoEntrega[] $cancelamentoEntrega
     */
    public function __construct(array $cancelamentoEntrega = array())
    {
        $this
            ->setCancelamentoEntrega($cancelamentoEntrega);
    }
    /**
     * Get CancelamentoEntrega value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CancelamentoEntrega[]|null
     */
    public function getCancelamentoEntrega()
    {
        return isset($this->CancelamentoEntrega) ? $this->CancelamentoEntrega : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCancelamentoEntrega method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCancelamentoEntrega method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCancelamentoEntregaForArrayConstraintsFromSetCancelamentoEntrega(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCancelamentoEntregaCancelamentoEntregaItem) {
            // validation for constraint: itemType
            if (!$arrayOfCancelamentoEntregaCancelamentoEntregaItem instanceof \StructType\CancelamentoEntrega) {
                $invalidValues[] = is_object($arrayOfCancelamentoEntregaCancelamentoEntregaItem) ? get_class($arrayOfCancelamentoEntregaCancelamentoEntregaItem) : sprintf('%s(%s)', gettype($arrayOfCancelamentoEntregaCancelamentoEntregaItem), var_export($arrayOfCancelamentoEntregaCancelamentoEntregaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CancelamentoEntrega property can only contain items of type \StructType\CancelamentoEntrega, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CancelamentoEntrega value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CancelamentoEntrega[] $cancelamentoEntrega
     * @return \ArrayType\ArrayOfCancelamentoEntrega
     */
    public function setCancelamentoEntrega(array $cancelamentoEntrega = array())
    {
        // validation for constraint: array
        if ('' !== ($cancelamentoEntregaArrayErrorMessage = self::validateCancelamentoEntregaForArrayConstraintsFromSetCancelamentoEntrega($cancelamentoEntrega))) {
            throw new \InvalidArgumentException($cancelamentoEntregaArrayErrorMessage, __LINE__);
        }
        if (is_null($cancelamentoEntrega) || (is_array($cancelamentoEntrega) && empty($cancelamentoEntrega))) {
            unset($this->CancelamentoEntrega);
        } else {
            $this->CancelamentoEntrega = $cancelamentoEntrega;
        }
        return $this;
    }
    /**
     * Add item to CancelamentoEntrega value
     * @throws \InvalidArgumentException
     * @param \StructType\CancelamentoEntrega $item
     * @return \ArrayType\ArrayOfCancelamentoEntrega
     */
    public function addToCancelamentoEntrega(\StructType\CancelamentoEntrega $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CancelamentoEntrega) {
            throw new \InvalidArgumentException(sprintf('The CancelamentoEntrega property can only contain items of type \StructType\CancelamentoEntrega, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CancelamentoEntrega[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CancelamentoEntrega|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CancelamentoEntrega|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CancelamentoEntrega|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CancelamentoEntrega|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CancelamentoEntrega|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CancelamentoEntrega
     */
    public function getAttributeName()
    {
        return 'CancelamentoEntrega';
    }
}
