<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRetornoCadProduto ArrayType
 * @subpackage Arrays
 */
class ArrayOfRetornoCadProduto extends AbstractStructArrayBase
{
    /**
     * The RetornoCadProduto
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RetornoCadProduto[]
     */
    public $RetornoCadProduto;
    /**
     * Constructor method for ArrayOfRetornoCadProduto
     * @uses ArrayOfRetornoCadProduto::setRetornoCadProduto()
     * @param \StructType\RetornoCadProduto[] $retornoCadProduto
     */
    public function __construct(array $retornoCadProduto = array())
    {
        $this
            ->setRetornoCadProduto($retornoCadProduto);
    }
    /**
     * Get RetornoCadProduto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RetornoCadProduto[]|null
     */
    public function getRetornoCadProduto()
    {
        return isset($this->RetornoCadProduto) ? $this->RetornoCadProduto : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRetornoCadProduto method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRetornoCadProduto method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRetornoCadProdutoForArrayConstraintsFromSetRetornoCadProduto(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRetornoCadProdutoRetornoCadProdutoItem) {
            // validation for constraint: itemType
            if (!$arrayOfRetornoCadProdutoRetornoCadProdutoItem instanceof \StructType\RetornoCadProduto) {
                $invalidValues[] = is_object($arrayOfRetornoCadProdutoRetornoCadProdutoItem) ? get_class($arrayOfRetornoCadProdutoRetornoCadProdutoItem) : sprintf('%s(%s)', gettype($arrayOfRetornoCadProdutoRetornoCadProdutoItem), var_export($arrayOfRetornoCadProdutoRetornoCadProdutoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RetornoCadProduto property can only contain items of type \StructType\RetornoCadProduto, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RetornoCadProduto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RetornoCadProduto[] $retornoCadProduto
     * @return \ArrayType\ArrayOfRetornoCadProduto
     */
    public function setRetornoCadProduto(array $retornoCadProduto = array())
    {
        // validation for constraint: array
        if ('' !== ($retornoCadProdutoArrayErrorMessage = self::validateRetornoCadProdutoForArrayConstraintsFromSetRetornoCadProduto($retornoCadProduto))) {
            throw new \InvalidArgumentException($retornoCadProdutoArrayErrorMessage, __LINE__);
        }
        if (is_null($retornoCadProduto) || (is_array($retornoCadProduto) && empty($retornoCadProduto))) {
            unset($this->RetornoCadProduto);
        } else {
            $this->RetornoCadProduto = $retornoCadProduto;
        }
        return $this;
    }
    /**
     * Add item to RetornoCadProduto value
     * @throws \InvalidArgumentException
     * @param \StructType\RetornoCadProduto $item
     * @return \ArrayType\ArrayOfRetornoCadProduto
     */
    public function addToRetornoCadProduto(\StructType\RetornoCadProduto $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RetornoCadProduto) {
            throw new \InvalidArgumentException(sprintf('The RetornoCadProduto property can only contain items of type \StructType\RetornoCadProduto, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RetornoCadProduto[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RetornoCadProduto|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RetornoCadProduto|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RetornoCadProduto|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RetornoCadProduto|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RetornoCadProduto|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RetornoCadProduto
     */
    public function getAttributeName()
    {
        return 'RetornoCadProduto';
    }
}
