<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRetornoCliente ArrayType
 * @subpackage Arrays
 */
class ArrayOfRetornoCliente extends AbstractStructArrayBase
{
    /**
     * The RetornoCliente
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RetornoCliente[]
     */
    public $RetornoCliente;
    /**
     * Constructor method for ArrayOfRetornoCliente
     * @uses ArrayOfRetornoCliente::setRetornoCliente()
     * @param \StructType\RetornoCliente[] $retornoCliente
     */
    public function __construct(array $retornoCliente = array())
    {
        $this
            ->setRetornoCliente($retornoCliente);
    }
    /**
     * Get RetornoCliente value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RetornoCliente[]|null
     */
    public function getRetornoCliente()
    {
        return isset($this->RetornoCliente) ? $this->RetornoCliente : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRetornoCliente method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRetornoCliente method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRetornoClienteForArrayConstraintsFromSetRetornoCliente(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRetornoClienteRetornoClienteItem) {
            // validation for constraint: itemType
            if (!$arrayOfRetornoClienteRetornoClienteItem instanceof \StructType\RetornoCliente) {
                $invalidValues[] = is_object($arrayOfRetornoClienteRetornoClienteItem) ? get_class($arrayOfRetornoClienteRetornoClienteItem) : sprintf('%s(%s)', gettype($arrayOfRetornoClienteRetornoClienteItem), var_export($arrayOfRetornoClienteRetornoClienteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RetornoCliente property can only contain items of type \StructType\RetornoCliente, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RetornoCliente value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RetornoCliente[] $retornoCliente
     * @return \ArrayType\ArrayOfRetornoCliente
     */
    public function setRetornoCliente(array $retornoCliente = array())
    {
        // validation for constraint: array
        if ('' !== ($retornoClienteArrayErrorMessage = self::validateRetornoClienteForArrayConstraintsFromSetRetornoCliente($retornoCliente))) {
            throw new \InvalidArgumentException($retornoClienteArrayErrorMessage, __LINE__);
        }
        if (is_null($retornoCliente) || (is_array($retornoCliente) && empty($retornoCliente))) {
            unset($this->RetornoCliente);
        } else {
            $this->RetornoCliente = $retornoCliente;
        }
        return $this;
    }
    /**
     * Add item to RetornoCliente value
     * @throws \InvalidArgumentException
     * @param \StructType\RetornoCliente $item
     * @return \ArrayType\ArrayOfRetornoCliente
     */
    public function addToRetornoCliente(\StructType\RetornoCliente $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RetornoCliente) {
            throw new \InvalidArgumentException(sprintf('The RetornoCliente property can only contain items of type \StructType\RetornoCliente, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RetornoCliente[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RetornoCliente|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RetornoCliente|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RetornoCliente|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RetornoCliente|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RetornoCliente|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RetornoCliente
     */
    public function getAttributeName()
    {
        return 'RetornoCliente';
    }
}
