<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRetornoEntrega ArrayType
 * @subpackage Arrays
 */
class ArrayOfRetornoEntrega extends AbstractStructArrayBase
{
    /**
     * The RetornoEntrega
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RetornoEntrega[]
     */
    public $RetornoEntrega;
    /**
     * Constructor method for ArrayOfRetornoEntrega
     * @uses ArrayOfRetornoEntrega::setRetornoEntrega()
     * @param \StructType\RetornoEntrega[] $retornoEntrega
     */
    public function __construct(array $retornoEntrega = array())
    {
        $this
            ->setRetornoEntrega($retornoEntrega);
    }
    /**
     * Get RetornoEntrega value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RetornoEntrega[]|null
     */
    public function getRetornoEntrega()
    {
        return isset($this->RetornoEntrega) ? $this->RetornoEntrega : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRetornoEntrega method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRetornoEntrega method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRetornoEntregaForArrayConstraintsFromSetRetornoEntrega(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRetornoEntregaRetornoEntregaItem) {
            // validation for constraint: itemType
            if (!$arrayOfRetornoEntregaRetornoEntregaItem instanceof \StructType\RetornoEntrega) {
                $invalidValues[] = is_object($arrayOfRetornoEntregaRetornoEntregaItem) ? get_class($arrayOfRetornoEntregaRetornoEntregaItem) : sprintf('%s(%s)', gettype($arrayOfRetornoEntregaRetornoEntregaItem), var_export($arrayOfRetornoEntregaRetornoEntregaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RetornoEntrega property can only contain items of type \StructType\RetornoEntrega, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RetornoEntrega value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RetornoEntrega[] $retornoEntrega
     * @return \ArrayType\ArrayOfRetornoEntrega
     */
    public function setRetornoEntrega(array $retornoEntrega = array())
    {
        // validation for constraint: array
        if ('' !== ($retornoEntregaArrayErrorMessage = self::validateRetornoEntregaForArrayConstraintsFromSetRetornoEntrega($retornoEntrega))) {
            throw new \InvalidArgumentException($retornoEntregaArrayErrorMessage, __LINE__);
        }
        if (is_null($retornoEntrega) || (is_array($retornoEntrega) && empty($retornoEntrega))) {
            unset($this->RetornoEntrega);
        } else {
            $this->RetornoEntrega = $retornoEntrega;
        }
        return $this;
    }
    /**
     * Add item to RetornoEntrega value
     * @throws \InvalidArgumentException
     * @param \StructType\RetornoEntrega $item
     * @return \ArrayType\ArrayOfRetornoEntrega
     */
    public function addToRetornoEntrega(\StructType\RetornoEntrega $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RetornoEntrega) {
            throw new \InvalidArgumentException(sprintf('The RetornoEntrega property can only contain items of type \StructType\RetornoEntrega, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RetornoEntrega[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RetornoEntrega|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RetornoEntrega|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RetornoEntrega|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RetornoEntrega|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RetornoEntrega|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RetornoEntrega
     */
    public function getAttributeName()
    {
        return 'RetornoEntrega';
    }
}
