<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRetornoRota ArrayType
 * @subpackage Arrays
 */
class ArrayOfRetornoRota extends AbstractStructArrayBase
{
    /**
     * The RetornoRota
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RetornoRota[]
     */
    public $RetornoRota;
    /**
     * Constructor method for ArrayOfRetornoRota
     * @uses ArrayOfRetornoRota::setRetornoRota()
     * @param \StructType\RetornoRota[] $retornoRota
     */
    public function __construct(array $retornoRota = array())
    {
        $this
            ->setRetornoRota($retornoRota);
    }
    /**
     * Get RetornoRota value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RetornoRota[]|null
     */
    public function getRetornoRota()
    {
        return isset($this->RetornoRota) ? $this->RetornoRota : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRetornoRota method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRetornoRota method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRetornoRotaForArrayConstraintsFromSetRetornoRota(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRetornoRotaRetornoRotaItem) {
            // validation for constraint: itemType
            if (!$arrayOfRetornoRotaRetornoRotaItem instanceof \StructType\RetornoRota) {
                $invalidValues[] = is_object($arrayOfRetornoRotaRetornoRotaItem) ? get_class($arrayOfRetornoRotaRetornoRotaItem) : sprintf('%s(%s)', gettype($arrayOfRetornoRotaRetornoRotaItem), var_export($arrayOfRetornoRotaRetornoRotaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RetornoRota property can only contain items of type \StructType\RetornoRota, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RetornoRota value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RetornoRota[] $retornoRota
     * @return \ArrayType\ArrayOfRetornoRota
     */
    public function setRetornoRota(array $retornoRota = array())
    {
        // validation for constraint: array
        if ('' !== ($retornoRotaArrayErrorMessage = self::validateRetornoRotaForArrayConstraintsFromSetRetornoRota($retornoRota))) {
            throw new \InvalidArgumentException($retornoRotaArrayErrorMessage, __LINE__);
        }
        if (is_null($retornoRota) || (is_array($retornoRota) && empty($retornoRota))) {
            unset($this->RetornoRota);
        } else {
            $this->RetornoRota = $retornoRota;
        }
        return $this;
    }
    /**
     * Add item to RetornoRota value
     * @throws \InvalidArgumentException
     * @param \StructType\RetornoRota $item
     * @return \ArrayType\ArrayOfRetornoRota
     */
    public function addToRetornoRota(\StructType\RetornoRota $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RetornoRota) {
            throw new \InvalidArgumentException(sprintf('The RetornoRota property can only contain items of type \StructType\RetornoRota, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RetornoRota[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RetornoRota|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RetornoRota|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RetornoRota|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RetornoRota|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RetornoRota|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RetornoRota
     */
    public function getAttributeName()
    {
        return 'RetornoRota';
    }
}
