<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRetornoViagem ArrayType
 * @subpackage Arrays
 */
class ArrayOfRetornoViagem extends AbstractStructArrayBase
{
    /**
     * The RetornoViagem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RetornoViagem[]
     */
    public $RetornoViagem;
    /**
     * Constructor method for ArrayOfRetornoViagem
     * @uses ArrayOfRetornoViagem::setRetornoViagem()
     * @param \StructType\RetornoViagem[] $retornoViagem
     */
    public function __construct(array $retornoViagem = array())
    {
        $this
            ->setRetornoViagem($retornoViagem);
    }
    /**
     * Get RetornoViagem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RetornoViagem[]|null
     */
    public function getRetornoViagem()
    {
        return isset($this->RetornoViagem) ? $this->RetornoViagem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRetornoViagem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRetornoViagem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRetornoViagemForArrayConstraintsFromSetRetornoViagem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRetornoViagemRetornoViagemItem) {
            // validation for constraint: itemType
            if (!$arrayOfRetornoViagemRetornoViagemItem instanceof \StructType\RetornoViagem) {
                $invalidValues[] = is_object($arrayOfRetornoViagemRetornoViagemItem) ? get_class($arrayOfRetornoViagemRetornoViagemItem) : sprintf('%s(%s)', gettype($arrayOfRetornoViagemRetornoViagemItem), var_export($arrayOfRetornoViagemRetornoViagemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RetornoViagem property can only contain items of type \StructType\RetornoViagem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RetornoViagem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RetornoViagem[] $retornoViagem
     * @return \ArrayType\ArrayOfRetornoViagem
     */
    public function setRetornoViagem(array $retornoViagem = array())
    {
        // validation for constraint: array
        if ('' !== ($retornoViagemArrayErrorMessage = self::validateRetornoViagemForArrayConstraintsFromSetRetornoViagem($retornoViagem))) {
            throw new \InvalidArgumentException($retornoViagemArrayErrorMessage, __LINE__);
        }
        if (is_null($retornoViagem) || (is_array($retornoViagem) && empty($retornoViagem))) {
            unset($this->RetornoViagem);
        } else {
            $this->RetornoViagem = $retornoViagem;
        }
        return $this;
    }
    /**
     * Add item to RetornoViagem value
     * @throws \InvalidArgumentException
     * @param \StructType\RetornoViagem $item
     * @return \ArrayType\ArrayOfRetornoViagem
     */
    public function addToRetornoViagem(\StructType\RetornoViagem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RetornoViagem) {
            throw new \InvalidArgumentException(sprintf('The RetornoViagem property can only contain items of type \StructType\RetornoViagem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RetornoViagem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RetornoViagem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RetornoViagem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RetornoViagem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RetornoViagem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RetornoViagem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RetornoViagem
     */
    public function getAttributeName()
    {
        return 'RetornoViagem';
    }
}
