<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUsuarioMobile ArrayType
 * @subpackage Arrays
 */
class ArrayOfUsuarioMobile extends AbstractStructArrayBase
{
    /**
     * The UsuarioMobile
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UsuarioMobile[]
     */
    public $UsuarioMobile;
    /**
     * Constructor method for ArrayOfUsuarioMobile
     * @uses ArrayOfUsuarioMobile::setUsuarioMobile()
     * @param \StructType\UsuarioMobile[] $usuarioMobile
     */
    public function __construct(array $usuarioMobile = array())
    {
        $this
            ->setUsuarioMobile($usuarioMobile);
    }
    /**
     * Get UsuarioMobile value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UsuarioMobile[]|null
     */
    public function getUsuarioMobile()
    {
        return isset($this->UsuarioMobile) ? $this->UsuarioMobile : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUsuarioMobile method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUsuarioMobile method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUsuarioMobileForArrayConstraintsFromSetUsuarioMobile(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUsuarioMobileUsuarioMobileItem) {
            // validation for constraint: itemType
            if (!$arrayOfUsuarioMobileUsuarioMobileItem instanceof \StructType\UsuarioMobile) {
                $invalidValues[] = is_object($arrayOfUsuarioMobileUsuarioMobileItem) ? get_class($arrayOfUsuarioMobileUsuarioMobileItem) : sprintf('%s(%s)', gettype($arrayOfUsuarioMobileUsuarioMobileItem), var_export($arrayOfUsuarioMobileUsuarioMobileItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UsuarioMobile property can only contain items of type \StructType\UsuarioMobile, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UsuarioMobile value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UsuarioMobile[] $usuarioMobile
     * @return \ArrayType\ArrayOfUsuarioMobile
     */
    public function setUsuarioMobile(array $usuarioMobile = array())
    {
        // validation for constraint: array
        if ('' !== ($usuarioMobileArrayErrorMessage = self::validateUsuarioMobileForArrayConstraintsFromSetUsuarioMobile($usuarioMobile))) {
            throw new \InvalidArgumentException($usuarioMobileArrayErrorMessage, __LINE__);
        }
        if (is_null($usuarioMobile) || (is_array($usuarioMobile) && empty($usuarioMobile))) {
            unset($this->UsuarioMobile);
        } else {
            $this->UsuarioMobile = $usuarioMobile;
        }
        return $this;
    }
    /**
     * Add item to UsuarioMobile value
     * @throws \InvalidArgumentException
     * @param \StructType\UsuarioMobile $item
     * @return \ArrayType\ArrayOfUsuarioMobile
     */
    public function addToUsuarioMobile(\StructType\UsuarioMobile $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UsuarioMobile) {
            throw new \InvalidArgumentException(sprintf('The UsuarioMobile property can only contain items of type \StructType\UsuarioMobile, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UsuarioMobile[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UsuarioMobile|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UsuarioMobile|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UsuarioMobile|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UsuarioMobile|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UsuarioMobile|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UsuarioMobile
     */
    public function getAttributeName()
    {
        return 'UsuarioMobile';
    }
}
