<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AgendarViagem' => '\\StructType\\AgendarViagem',
            '_Viagens' => '\\StructType\\_Viagens',
            'AgendarViagemResponse' => '\\StructType\\AgendarViagemResponse',
            'ArrayOfRetornoViagem' => '\\ArrayType\\ArrayOfRetornoViagem',
            'RetornoViagem' => '\\StructType\\RetornoViagem',
            'RetornoInclusao' => '\\StructType\\RetornoInclusao',
            'Retorno' => '\\StructType\\Retorno',
            'ValidationSoapHeader' => '\\StructType\\ValidationSoapHeader',
            'CadastrarCliente' => '\\StructType\\CadastrarCliente',
            'ArrayOfCliente' => '\\ArrayType\\ArrayOfCliente',
            'Cliente' => '\\StructType\\Cliente',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'CadastrarClienteResponse' => '\\StructType\\CadastrarClienteResponse',
            'ArrayOfRetornoCliente' => '\\ArrayType\\ArrayOfRetornoCliente',
            'RetornoCliente' => '\\StructType\\RetornoCliente',
            'GetProcedimentoEmbarque' => '\\StructType\\GetProcedimentoEmbarque',
            'GetProcedimentoEmbarqueResponse' => '\\StructType\\GetProcedimentoEmbarqueResponse',
            'ArrayOfRetornoItem' => '\\ArrayType\\ArrayOfRetornoItem',
            'RetornoItem' => '\\StructType\\RetornoItem',
            'GetFaixaTemperatura' => '\\StructType\\GetFaixaTemperatura',
            'GetFaixaTemperaturaResponse' => '\\StructType\\GetFaixaTemperaturaResponse',
            'GetRotas' => '\\StructType\\GetRotas',
            'PesquisaRota' => '\\StructType\\PesquisaRota',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'GetRotasResponse' => '\\StructType\\GetRotasResponse',
            'ArrayOfRetornoRota' => '\\ArrayType\\ArrayOfRetornoRota',
            'RetornoRota' => '\\StructType\\RetornoRota',
            'GetRota' => '\\StructType\\GetRota',
            'GetRotaResponse' => '\\StructType\\GetRotaResponse',
            'CancelarEntrega' => '\\StructType\\CancelarEntrega',
            'ArrayOfCancelamentoEntrega' => '\\ArrayType\\ArrayOfCancelamentoEntrega',
            'CancelamentoEntrega' => '\\StructType\\CancelamentoEntrega',
            'Cancelamento' => '\\StructType\\Cancelamento',
            'CancelarEntregaResponse' => '\\StructType\\CancelarEntregaResponse',
            'ArrayOfRetornoEntrega' => '\\ArrayType\\ArrayOfRetornoEntrega',
            'RetornoEntrega' => '\\StructType\\RetornoEntrega',
            'CancelarViagem' => '\\StructType\\CancelarViagem',
            'ArrayOfCancelamento' => '\\ArrayType\\ArrayOfCancelamento',
            'CancelarViagemResponse' => '\\StructType\\CancelarViagemResponse',
            'CadastrarTipoOcorrencia' => '\\StructType\\CadastrarTipoOcorrencia',
            'TipoOcorrencia' => '\\StructType\\TipoOcorrencia',
            'CadastrarTipoOcorrenciaResponse' => '\\StructType\\CadastrarTipoOcorrenciaResponse',
            'CadastrarProduto' => '\\StructType\\CadastrarProduto',
            'ArrayOfCadProduto' => '\\ArrayType\\ArrayOfCadProduto',
            'CadProduto' => '\\StructType\\CadProduto',
            'CadastrarProdutoResponse' => '\\StructType\\CadastrarProdutoResponse',
            'ArrayOfRetornoCadProduto' => '\\ArrayType\\ArrayOfRetornoCadProduto',
            'RetornoCadProduto' => '\\StructType\\RetornoCadProduto',
            'AtualizarRotaViagem' => '\\StructType\\AtualizarRotaViagem',
            'TrechoRotaViagem' => '\\StructType\\TrechoRotaViagem',
            'ArrayOfTrecho' => '\\ArrayType\\ArrayOfTrecho',
            'Trecho' => '\\StructType\\Trecho',
            'AtualizarRotaViagemResponse' => '\\StructType\\AtualizarRotaViagemResponse',
            'RetornoCadTrechoRota' => '\\StructType\\RetornoCadTrechoRota',
            'ListaTCAFranquia' => '\\StructType\\ListaTCAFranquia',
            'ListaTCAFranquiaResponse' => '\\StructType\\ListaTCAFranquiaResponse',
            'CadastrarUnidadePagadora' => '\\StructType\\CadastrarUnidadePagadora',
            'CadastrarUnidadePagadoraResponse' => '\\StructType\\CadastrarUnidadePagadoraResponse',
            'CadastrarAlocacaoDeCusto' => '\\StructType\\CadastrarAlocacaoDeCusto',
            'CadastrarAlocacaoDeCustoResponse' => '\\StructType\\CadastrarAlocacaoDeCustoResponse',
            'SequenciarEntregas' => '\\StructType\\SequenciarEntregas',
            'WayPoint' => '\\StructType\\WayPoint',
            'ArrayOfWayPoint' => '\\ArrayType\\ArrayOfWayPoint',
            'SequenciarEntregasResponse' => '\\StructType\\SequenciarEntregasResponse',
            'GetDispositivoAssociado' => '\\StructType\\GetDispositivoAssociado',
            'GetDispositivoAssociadoResponse' => '\\StructType\\GetDispositivoAssociadoResponse',
            'ArrayOfUsuarioMobile' => '\\ArrayType\\ArrayOfUsuarioMobile',
            'UsuarioMobile' => '\\StructType\\UsuarioMobile',
            'IniciarViagem' => '\\StructType\\IniciarViagem',
            'IdentificadorViagem' => '\\StructType\\IdentificadorViagem',
            'IniciarViagemResponse' => '\\StructType\\IniciarViagemResponse',
            'FinalizarViagem' => '\\StructType\\FinalizarViagem',
            'FinalizarViagemResponse' => '\\StructType\\FinalizarViagemResponse',
            'EnviarIdentificacaoViagem' => '\\StructType\\EnviarIdentificacaoViagem',
            'EnviarIdentificacaoViagemResponse' => '\\StructType\\EnviarIdentificacaoViagemResponse',
        );
    }
}
