<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Cliente StructType
 * @subpackage Structs
 */
class Cliente extends AbstractStructBase
{
    /**
     * The isTransportador
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $isTransportador;
    /**
     * The latitude
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $latitude;
    /**
     * The longitude
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $longitude;
    /**
     * The raio
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $raio;
    /**
     * The id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $id;
    /**
     * The cnpj
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $cnpj;
    /**
     * The cpf
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $cpf;
    /**
     * The nome
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $nome;
    /**
     * The fantasia
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $fantasia;
    /**
     * The endereco
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $endereco;
    /**
     * The numero
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $numero;
    /**
     * The complemento
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $complemento;
    /**
     * The bairro
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $bairro;
    /**
     * The cidade
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $cidade;
    /**
     * The uf
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $uf;
    /**
     * The pais
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $pais;
    /**
     * The cep
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $cep;
    /**
     * The observacao
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $observacao;
    /**
     * The poligono
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $poligono;
    /**
     * The procedimentos
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt
     */
    public $procedimentos;
    /**
     * Constructor method for Cliente
     * @uses Cliente::setIsTransportador()
     * @uses Cliente::setLatitude()
     * @uses Cliente::setLongitude()
     * @uses Cliente::setRaio()
     * @uses Cliente::setId()
     * @uses Cliente::setCnpj()
     * @uses Cliente::setCpf()
     * @uses Cliente::setNome()
     * @uses Cliente::setFantasia()
     * @uses Cliente::setEndereco()
     * @uses Cliente::setNumero()
     * @uses Cliente::setComplemento()
     * @uses Cliente::setBairro()
     * @uses Cliente::setCidade()
     * @uses Cliente::setUf()
     * @uses Cliente::setPais()
     * @uses Cliente::setCep()
     * @uses Cliente::setObservacao()
     * @uses Cliente::setPoligono()
     * @uses Cliente::setProcedimentos()
     * @param bool $isTransportador
     * @param float $latitude
     * @param float $longitude
     * @param float $raio
     * @param string $id
     * @param string $cnpj
     * @param string $cpf
     * @param string $nome
     * @param string $fantasia
     * @param string $endereco
     * @param string $numero
     * @param string $complemento
     * @param string $bairro
     * @param string $cidade
     * @param string $uf
     * @param string $pais
     * @param string $cep
     * @param string $observacao
     * @param string $poligono
     * @param \ArrayType\ArrayOfInt $procedimentos
     */
    public function __construct($isTransportador = null, $latitude = null, $longitude = null, $raio = null, $id = null, $cnpj = null, $cpf = null, $nome = null, $fantasia = null, $endereco = null, $numero = null, $complemento = null, $bairro = null, $cidade = null, $uf = null, $pais = null, $cep = null, $observacao = null, $poligono = null, \ArrayType\ArrayOfInt $procedimentos = null)
    {
        $this
            ->setIsTransportador($isTransportador)
            ->setLatitude($latitude)
            ->setLongitude($longitude)
            ->setRaio($raio)
            ->setId($id)
            ->setCnpj($cnpj)
            ->setCpf($cpf)
            ->setNome($nome)
            ->setFantasia($fantasia)
            ->setEndereco($endereco)
            ->setNumero($numero)
            ->setComplemento($complemento)
            ->setBairro($bairro)
            ->setCidade($cidade)
            ->setUf($uf)
            ->setPais($pais)
            ->setCep($cep)
            ->setObservacao($observacao)
            ->setPoligono($poligono)
            ->setProcedimentos($procedimentos);
    }
    /**
     * Get isTransportador value
     * @return bool
     */
    public function getIsTransportador()
    {
        return $this->isTransportador;
    }
    /**
     * Set isTransportador value
     * @param bool $isTransportador
     * @return \StructType\Cliente
     */
    public function setIsTransportador($isTransportador = null)
    {
        // validation for constraint: boolean
        if (!is_null($isTransportador) && !is_bool($isTransportador)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isTransportador, true), gettype($isTransportador)), __LINE__);
        }
        $this->isTransportador = $isTransportador;
        return $this;
    }
    /**
     * Get latitude value
     * @return float
     */
    public function getLatitude()
    {
        return $this->latitude;
    }
    /**
     * Set latitude value
     * @param float $latitude
     * @return \StructType\Cliente
     */
    public function setLatitude($latitude = null)
    {
        // validation for constraint: float
        if (!is_null($latitude) && !(is_float($latitude) || is_numeric($latitude))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($latitude, true), gettype($latitude)), __LINE__);
        }
        $this->latitude = $latitude;
        return $this;
    }
    /**
     * Get longitude value
     * @return float
     */
    public function getLongitude()
    {
        return $this->longitude;
    }
    /**
     * Set longitude value
     * @param float $longitude
     * @return \StructType\Cliente
     */
    public function setLongitude($longitude = null)
    {
        // validation for constraint: float
        if (!is_null($longitude) && !(is_float($longitude) || is_numeric($longitude))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($longitude, true), gettype($longitude)), __LINE__);
        }
        $this->longitude = $longitude;
        return $this;
    }
    /**
     * Get raio value
     * @return float
     */
    public function getRaio()
    {
        return $this->raio;
    }
    /**
     * Set raio value
     * @param float $raio
     * @return \StructType\Cliente
     */
    public function setRaio($raio = null)
    {
        // validation for constraint: float
        if (!is_null($raio) && !(is_float($raio) || is_numeric($raio))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($raio, true), gettype($raio)), __LINE__);
        }
        $this->raio = $raio;
        return $this;
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\Cliente
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get cnpj value
     * @return string|null
     */
    public function getCnpj()
    {
        return $this->cnpj;
    }
    /**
     * Set cnpj value
     * @param string $cnpj
     * @return \StructType\Cliente
     */
    public function setCnpj($cnpj = null)
    {
        // validation for constraint: string
        if (!is_null($cnpj) && !is_string($cnpj)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cnpj, true), gettype($cnpj)), __LINE__);
        }
        $this->cnpj = $cnpj;
        return $this;
    }
    /**
     * Get cpf value
     * @return string|null
     */
    public function getCpf()
    {
        return $this->cpf;
    }
    /**
     * Set cpf value
     * @param string $cpf
     * @return \StructType\Cliente
     */
    public function setCpf($cpf = null)
    {
        // validation for constraint: string
        if (!is_null($cpf) && !is_string($cpf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cpf, true), gettype($cpf)), __LINE__);
        }
        $this->cpf = $cpf;
        return $this;
    }
    /**
     * Get nome value
     * @return string|null
     */
    public function getNome()
    {
        return $this->nome;
    }
    /**
     * Set nome value
     * @param string $nome
     * @return \StructType\Cliente
     */
    public function setNome($nome = null)
    {
        // validation for constraint: string
        if (!is_null($nome) && !is_string($nome)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nome, true), gettype($nome)), __LINE__);
        }
        $this->nome = $nome;
        return $this;
    }
    /**
     * Get fantasia value
     * @return string|null
     */
    public function getFantasia()
    {
        return $this->fantasia;
    }
    /**
     * Set fantasia value
     * @param string $fantasia
     * @return \StructType\Cliente
     */
    public function setFantasia($fantasia = null)
    {
        // validation for constraint: string
        if (!is_null($fantasia) && !is_string($fantasia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fantasia, true), gettype($fantasia)), __LINE__);
        }
        $this->fantasia = $fantasia;
        return $this;
    }
    /**
     * Get endereco value
     * @return string|null
     */
    public function getEndereco()
    {
        return $this->endereco;
    }
    /**
     * Set endereco value
     * @param string $endereco
     * @return \StructType\Cliente
     */
    public function setEndereco($endereco = null)
    {
        // validation for constraint: string
        if (!is_null($endereco) && !is_string($endereco)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endereco, true), gettype($endereco)), __LINE__);
        }
        $this->endereco = $endereco;
        return $this;
    }
    /**
     * Get numero value
     * @return string|null
     */
    public function getNumero()
    {
        return $this->numero;
    }
    /**
     * Set numero value
     * @param string $numero
     * @return \StructType\Cliente
     */
    public function setNumero($numero = null)
    {
        // validation for constraint: string
        if (!is_null($numero) && !is_string($numero)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numero, true), gettype($numero)), __LINE__);
        }
        $this->numero = $numero;
        return $this;
    }
    /**
     * Get complemento value
     * @return string|null
     */
    public function getComplemento()
    {
        return $this->complemento;
    }
    /**
     * Set complemento value
     * @param string $complemento
     * @return \StructType\Cliente
     */
    public function setComplemento($complemento = null)
    {
        // validation for constraint: string
        if (!is_null($complemento) && !is_string($complemento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($complemento, true), gettype($complemento)), __LINE__);
        }
        $this->complemento = $complemento;
        return $this;
    }
    /**
     * Get bairro value
     * @return string|null
     */
    public function getBairro()
    {
        return $this->bairro;
    }
    /**
     * Set bairro value
     * @param string $bairro
     * @return \StructType\Cliente
     */
    public function setBairro($bairro = null)
    {
        // validation for constraint: string
        if (!is_null($bairro) && !is_string($bairro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bairro, true), gettype($bairro)), __LINE__);
        }
        $this->bairro = $bairro;
        return $this;
    }
    /**
     * Get cidade value
     * @return string|null
     */
    public function getCidade()
    {
        return $this->cidade;
    }
    /**
     * Set cidade value
     * @param string $cidade
     * @return \StructType\Cliente
     */
    public function setCidade($cidade = null)
    {
        // validation for constraint: string
        if (!is_null($cidade) && !is_string($cidade)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cidade, true), gettype($cidade)), __LINE__);
        }
        $this->cidade = $cidade;
        return $this;
    }
    /**
     * Get uf value
     * @return string|null
     */
    public function getUf()
    {
        return $this->uf;
    }
    /**
     * Set uf value
     * @param string $uf
     * @return \StructType\Cliente
     */
    public function setUf($uf = null)
    {
        // validation for constraint: string
        if (!is_null($uf) && !is_string($uf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uf, true), gettype($uf)), __LINE__);
        }
        $this->uf = $uf;
        return $this;
    }
    /**
     * Get pais value
     * @return string|null
     */
    public function getPais()
    {
        return $this->pais;
    }
    /**
     * Set pais value
     * @param string $pais
     * @return \StructType\Cliente
     */
    public function setPais($pais = null)
    {
        // validation for constraint: string
        if (!is_null($pais) && !is_string($pais)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pais, true), gettype($pais)), __LINE__);
        }
        $this->pais = $pais;
        return $this;
    }
    /**
     * Get cep value
     * @return string|null
     */
    public function getCep()
    {
        return $this->cep;
    }
    /**
     * Set cep value
     * @param string $cep
     * @return \StructType\Cliente
     */
    public function setCep($cep = null)
    {
        // validation for constraint: string
        if (!is_null($cep) && !is_string($cep)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cep, true), gettype($cep)), __LINE__);
        }
        $this->cep = $cep;
        return $this;
    }
    /**
     * Get observacao value
     * @return string|null
     */
    public function getObservacao()
    {
        return $this->observacao;
    }
    /**
     * Set observacao value
     * @param string $observacao
     * @return \StructType\Cliente
     */
    public function setObservacao($observacao = null)
    {
        // validation for constraint: string
        if (!is_null($observacao) && !is_string($observacao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($observacao, true), gettype($observacao)), __LINE__);
        }
        $this->observacao = $observacao;
        return $this;
    }
    /**
     * Get poligono value
     * @return string|null
     */
    public function getPoligono()
    {
        return $this->poligono;
    }
    /**
     * Set poligono value
     * @param string $poligono
     * @return \StructType\Cliente
     */
    public function setPoligono($poligono = null)
    {
        // validation for constraint: string
        if (!is_null($poligono) && !is_string($poligono)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($poligono, true), gettype($poligono)), __LINE__);
        }
        $this->poligono = $poligono;
        return $this;
    }
    /**
     * Get procedimentos value
     * @return \ArrayType\ArrayOfInt|null
     */
    public function getProcedimentos()
    {
        return $this->procedimentos;
    }
    /**
     * Set procedimentos value
     * @param \ArrayType\ArrayOfInt $procedimentos
     * @return \StructType\Cliente
     */
    public function setProcedimentos(\ArrayType\ArrayOfInt $procedimentos = null)
    {
        $this->procedimentos = $procedimentos;
        return $this;
    }
}
