<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RetornoCadTrechoRota StructType
 * @subpackage Structs
 */
class RetornoCadTrechoRota extends AbstractStructBase
{
    /**
     * The status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $status;
    /**
     * The codigo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $codigo;
    /**
     * The v_carga
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $v_carga;
    /**
     * The motivo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $motivo;
    /**
     * Constructor method for RetornoCadTrechoRota
     * @uses RetornoCadTrechoRota::setStatus()
     * @uses RetornoCadTrechoRota::setCodigo()
     * @uses RetornoCadTrechoRota::setV_carga()
     * @uses RetornoCadTrechoRota::setMotivo()
     * @param int $status
     * @param int $codigo
     * @param string $v_carga
     * @param string $motivo
     */
    public function __construct($status = null, $codigo = null, $v_carga = null, $motivo = null)
    {
        $this
            ->setStatus($status)
            ->setCodigo($codigo)
            ->setV_carga($v_carga)
            ->setMotivo($motivo);
    }
    /**
     * Get status value
     * @return int
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param int $status
     * @return \StructType\RetornoCadTrechoRota
     */
    public function setStatus($status = null)
    {
        // validation for constraint: int
        if (!is_null($status) && !(is_int($status) || ctype_digit($status))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get codigo value
     * @return int|null
     */
    public function getCodigo()
    {
        return $this->codigo;
    }
    /**
     * Set codigo value
     * @param int $codigo
     * @return \StructType\RetornoCadTrechoRota
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: int
        if (!is_null($codigo) && !(is_int($codigo) || ctype_digit($codigo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        $this->codigo = $codigo;
        return $this;
    }
    /**
     * Get v_carga value
     * @return string|null
     */
    public function getV_carga()
    {
        return $this->v_carga;
    }
    /**
     * Set v_carga value
     * @param string $v_carga
     * @return \StructType\RetornoCadTrechoRota
     */
    public function setV_carga($v_carga = null)
    {
        // validation for constraint: string
        if (!is_null($v_carga) && !is_string($v_carga)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($v_carga, true), gettype($v_carga)), __LINE__);
        }
        $this->v_carga = $v_carga;
        return $this;
    }
    /**
     * Get motivo value
     * @return string|null
     */
    public function getMotivo()
    {
        return $this->motivo;
    }
    /**
     * Set motivo value
     * @param string $motivo
     * @return \StructType\RetornoCadTrechoRota
     */
    public function setMotivo($motivo = null)
    {
        // validation for constraint: string
        if (!is_null($motivo) && !is_string($motivo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($motivo, true), gettype($motivo)), __LINE__);
        }
        $this->motivo = $motivo;
        return $this;
    }
}
