<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TipoOcorrencia StructType
 * @subpackage Structs
 */
class TipoOcorrencia extends AbstractStructBase
{
    /**
     * The obrigaFoto
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $obrigaFoto;
    /**
     * The obrigaObs
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $obrigaObs;
    /**
     * The isCancelamento
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $isCancelamento;
    /**
     * The isAtivo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $isAtivo;
    /**
     * The isInterno
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $isInterno;
    /**
     * The isOcultaEntrega
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $isOcultaEntrega;
    /**
     * The id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $id;
    /**
     * The descricao
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $descricao;
    /**
     * Constructor method for TipoOcorrencia
     * @uses TipoOcorrencia::setObrigaFoto()
     * @uses TipoOcorrencia::setObrigaObs()
     * @uses TipoOcorrencia::setIsCancelamento()
     * @uses TipoOcorrencia::setIsAtivo()
     * @uses TipoOcorrencia::setIsInterno()
     * @uses TipoOcorrencia::setIsOcultaEntrega()
     * @uses TipoOcorrencia::setId()
     * @uses TipoOcorrencia::setDescricao()
     * @param bool $obrigaFoto
     * @param bool $obrigaObs
     * @param bool $isCancelamento
     * @param bool $isAtivo
     * @param bool $isInterno
     * @param bool $isOcultaEntrega
     * @param string $id
     * @param string $descricao
     */
    public function __construct($obrigaFoto = null, $obrigaObs = null, $isCancelamento = null, $isAtivo = null, $isInterno = null, $isOcultaEntrega = null, $id = null, $descricao = null)
    {
        $this
            ->setObrigaFoto($obrigaFoto)
            ->setObrigaObs($obrigaObs)
            ->setIsCancelamento($isCancelamento)
            ->setIsAtivo($isAtivo)
            ->setIsInterno($isInterno)
            ->setIsOcultaEntrega($isOcultaEntrega)
            ->setId($id)
            ->setDescricao($descricao);
    }
    /**
     * Get obrigaFoto value
     * @return bool
     */
    public function getObrigaFoto()
    {
        return $this->obrigaFoto;
    }
    /**
     * Set obrigaFoto value
     * @param bool $obrigaFoto
     * @return \StructType\TipoOcorrencia
     */
    public function setObrigaFoto($obrigaFoto = null)
    {
        // validation for constraint: boolean
        if (!is_null($obrigaFoto) && !is_bool($obrigaFoto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($obrigaFoto, true), gettype($obrigaFoto)), __LINE__);
        }
        $this->obrigaFoto = $obrigaFoto;
        return $this;
    }
    /**
     * Get obrigaObs value
     * @return bool
     */
    public function getObrigaObs()
    {
        return $this->obrigaObs;
    }
    /**
     * Set obrigaObs value
     * @param bool $obrigaObs
     * @return \StructType\TipoOcorrencia
     */
    public function setObrigaObs($obrigaObs = null)
    {
        // validation for constraint: boolean
        if (!is_null($obrigaObs) && !is_bool($obrigaObs)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($obrigaObs, true), gettype($obrigaObs)), __LINE__);
        }
        $this->obrigaObs = $obrigaObs;
        return $this;
    }
    /**
     * Get isCancelamento value
     * @return bool
     */
    public function getIsCancelamento()
    {
        return $this->isCancelamento;
    }
    /**
     * Set isCancelamento value
     * @param bool $isCancelamento
     * @return \StructType\TipoOcorrencia
     */
    public function setIsCancelamento($isCancelamento = null)
    {
        // validation for constraint: boolean
        if (!is_null($isCancelamento) && !is_bool($isCancelamento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isCancelamento, true), gettype($isCancelamento)), __LINE__);
        }
        $this->isCancelamento = $isCancelamento;
        return $this;
    }
    /**
     * Get isAtivo value
     * @return bool
     */
    public function getIsAtivo()
    {
        return $this->isAtivo;
    }
    /**
     * Set isAtivo value
     * @param bool $isAtivo
     * @return \StructType\TipoOcorrencia
     */
    public function setIsAtivo($isAtivo = null)
    {
        // validation for constraint: boolean
        if (!is_null($isAtivo) && !is_bool($isAtivo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isAtivo, true), gettype($isAtivo)), __LINE__);
        }
        $this->isAtivo = $isAtivo;
        return $this;
    }
    /**
     * Get isInterno value
     * @return bool
     */
    public function getIsInterno()
    {
        return $this->isInterno;
    }
    /**
     * Set isInterno value
     * @param bool $isInterno
     * @return \StructType\TipoOcorrencia
     */
    public function setIsInterno($isInterno = null)
    {
        // validation for constraint: boolean
        if (!is_null($isInterno) && !is_bool($isInterno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isInterno, true), gettype($isInterno)), __LINE__);
        }
        $this->isInterno = $isInterno;
        return $this;
    }
    /**
     * Get isOcultaEntrega value
     * @return bool
     */
    public function getIsOcultaEntrega()
    {
        return $this->isOcultaEntrega;
    }
    /**
     * Set isOcultaEntrega value
     * @param bool $isOcultaEntrega
     * @return \StructType\TipoOcorrencia
     */
    public function setIsOcultaEntrega($isOcultaEntrega = null)
    {
        // validation for constraint: boolean
        if (!is_null($isOcultaEntrega) && !is_bool($isOcultaEntrega)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isOcultaEntrega, true), gettype($isOcultaEntrega)), __LINE__);
        }
        $this->isOcultaEntrega = $isOcultaEntrega;
        return $this;
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\TipoOcorrencia
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get descricao value
     * @return string|null
     */
    public function getDescricao()
    {
        return $this->descricao;
    }
    /**
     * Set descricao value
     * @param string $descricao
     * @return \StructType\TipoOcorrencia
     */
    public function setDescricao($descricao = null)
    {
        // validation for constraint: string
        if (!is_null($descricao) && !is_string($descricao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descricao, true), gettype($descricao)), __LINE__);
        }
        $this->descricao = $descricao;
        return $this;
    }
}
